import java.net.*;
import java.io.*;
import java.util.*;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;
import java.awt.*;
import java.awt.event.*;

@SuppressWarnings("serial")
public class Server extends Frame implements WindowListener, KeyListener {
	static int port = 8080;
	static int clients = 2;
	static int countclients = 0;
	static int countclientsthread = 0;
	static final Lock lock = new ReentrantLock();
	static Hashtable<ServeClient, Double> ClientList;
	static String trajectory;
	static TextArea logDisplay;
	String file = "./query.txt";
	static ArrayList<ThreadUB> UBLCSSthread;
	ThreadUB[] UBtable;
	ServerSocket listenSocket;
	Socket connection;
	OutputStream outStream;
	DataOutputStream outDataStream;
	TextField filetext;
	String message;
	private boolean nextoption = false;
	boolean flag = true;

	public Server() {
		super("Server");
		logDisplay = new TextArea(40, 10);
		add(BorderLayout.CENTER, logDisplay);
		filetext = new TextField();
		filetext.addKeyListener(this);
		add(BorderLayout.PAGE_END, filetext);
		addWindowListener(this);
		setSize(400, 300);
		setVisible(true);

	} // end Server_Basic constructor

	public void runServer() {
		try {

			logDisplay.setEditable(false);
			listenSocket = new ServerSocket(port);
			logDisplay.setText("Server started \n");
			try {
				InetAddress here = InetAddress.getLocalHost();
				String host = here.getHostName();
				// get Server's ip address
				IPaddress ip = new IPaddress();
				logDisplay.append("on " + host + " with ip:"
						+ ip.getInterfaces() + "\nport :" + port + "\n");
			} catch (UnknownHostException e) {
				logDisplay.setText("Problem with local host\n");
			}
			logDisplay.append("Please give the clients number at bottom"
					+ " of the window\n");
			while (flag)
				try {
					Thread.sleep(500);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			flag = true;
			logDisplay.append("Please give the file at bottom"
					+ " of the window\n");
			while (flag)
				try {
					Thread.sleep(500);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			// wait while clients are connected
			while (true) {
				// initialize the counter for the clients and the tables
				countclients = 0;
				countclientsthread = 0;
				ClientList = new Hashtable<ServeClient, Double>();
				UBLCSSthread = new ArrayList<ThreadUB>();
				do {
					connection = listenSocket.accept();
					logDisplay.append("Connection request received\n");
					ServeClient thread = new ServeClient(connection);
					lock.lock();
					ClientList.put(thread, 0.0);
					countclients++;
					lock.unlock();
					thread.start();
				} while (countclients < clients);
				// wait until all threads are started
				while (countclientsthread < clients) {
					try {
						Thread.sleep(500);
					} catch (InterruptedException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
				UBtable = new ThreadUB[clients];
				// for each element in hash table
				Set<ServeClient> set = ClientList.keySet();
				Iterator<ServeClient> itr = set.iterator();
				ThreadUB temp;
				int i = 0;
				while (itr.hasNext()) {
					temp = new ThreadUB();
					temp.thread = itr.next();
					temp.UB = temp.thread.UB;
					UBtable[i++] = temp;
				}
				// sort the array based on my comparator
				Arrays.sort(UBtable, new mycomparator());
				// the first and the second of elements is the element with the
				// biggest UB
				UBtable[0].thread.Oktraj = true;
				UBtable[0].thread.wait = false;
				UBtable[1].thread.Oktraj = true;
				UBtable[1].thread.wait = false;
				// wait for all threads
				while (UBLCSSthread.size() < 2) {
					try {
						Thread.sleep(500);
					} catch (InterruptedException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
				// the second element
				i = 2;
				Collections.sort(UBLCSSthread, new mycomparator());
				for (i = 2; i < UBtable.length; i++) {
					if (UBLCSSthread.get(0).UB < UBtable[i].UB) {
						UBtable[i].thread.Oktraj = true;
					}
					UBtable[i].thread.wait = false;
				}
				for (int j = i; j < UBtable.length; j++) {
					UBtable[j].thread.wait = false;
				}
				Collections.sort(UBLCSSthread, new mycomparator());
				logDisplay
						.append("The ip that has the most similar trajectory is "
								+ UBLCSSthread.get(0).thread.connection
										.getInetAddress() + "\n");

			}// end of while(true)
		} // end try
		catch (IOException except) {
			except.printStackTrace();
		} // end catch
	} // end runServer

	public static void main(String[] args) {

		Server server = new Server();

		server.runServer();

	} // end main

	public void windowActivated(WindowEvent e) {
	}

	public void windowDeactivated(WindowEvent e) {
	}

	public void windowOpened(WindowEvent e) {
	}

	public void windowClosed(WindowEvent e) {
	}

	public void windowClosing(WindowEvent e) {
		setVisible(false);
		this.dispose();
		System.exit(0);
	}

	public void windowIconified(WindowEvent e) {
	}

	public void windowDeiconified(WindowEvent e) {
	}

	/** Handle the key typed event from the text field. */
	public void keyTyped(KeyEvent e) {
		if (e.getKeyChar() == '\n' && filetext.isEditable()) {
			if (!nextoption) {
				if (!isIntNumber(filetext.getText())) {
					logDisplay
							.append("You gave wrong clients's number.\nThe default number (2) will be used\n");
				} else {
					clients = Integer.parseInt(filetext.getText());
					if (clients < 2) {
						logDisplay
								.append("You gave invalid clients's number.\nThe default number (2) will be used\n");
						clients = 2;
					} else

						logDisplay.append("You gave " + clients + " clients\n");
				}
				filetext.setText("");
				flag = false;
				nextoption = true;
			} else {
				file = filetext.getText();
				logDisplay.append("The given file is " + file + "\n");
				readFromFile(file);
				logDisplay.append("The given trajectory is " + trajectory
						+ "\n");
				flag = false;
				filetext.setText("The server has started!");
				filetext.setEditable(false);
			}
		}
	}

	@Override
	public void keyPressed(KeyEvent arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void keyReleased(KeyEvent arg0) {
		// TODO Auto-generated method stub
	}

	public void readFromFile(String file) {
		BufferedReader reader = null;
		try {
			File inFile = new File(file);
			if (!inFile.exists()) {
				inFile = new File("./query.txt");
				logDisplay
						.append("You gave a file that does not exist.\nThe default file (query.txt) will be used\n");
			}
			reader = new BufferedReader(new FileReader(inFile));
		} catch (Exception e) {
			System.err.println("Error when opening file:\n" + e.getMessage());
		}

		trajectory = "";
		String line;
		// get the Latitude from file and store it to an array
		try {

			while ((line = reader.readLine()) != null) {
				trajectory += line + ",";
			}
		} catch (Exception e) {
			System.err.println("Exception while reading from file:\n"
					+ e.getMessage());
		}
	}

	private boolean isIntNumber(String num) {
		try {
			Integer.parseInt(num);
		} catch (NumberFormatException nfe) {
			return false;
		}
		return true;
	}

} // end Server_Basic
// create comparator for sorting the array

class mycomparator implements Comparator<ThreadUB> {
	public int compare(ThreadUB o1, ThreadUB o2) {
		// TODO Auto-generated method stub
		return (o1.UB > o2.UB ? -1 : (o1.UB == o2.UB ? 0 : 1));

	}
}

// class to store UB and the thread of that UB
class ThreadUB {
	double UB;
	ServeClient thread;

	ThreadUB() {
		UB = -1;
		thread = new ServeClient(null);
	}
}
